"""
Shows basic usage of the Google Calendar API. Creates a Google Calendar API
service object and outputs a list of the next 10 events on the user's calendar.
"""
from __future__ import print_function
from apiclient.discovery import build
from httplib2 import Http
from oauth2client import file, client, tools
import datetime
import os

# Setup the Calendar API
SCOPES = 'https://www.googleapis.com/auth/calendar.readonly'
text = ""
store = file.Storage('.token.json')
creds = store.get()
if not creds or creds.invalid:
    flow = client.flow_from_clientsecrets('.credentials.json', SCOPES)
    creds = tools.run_flow(flow, store)
service = build('calendar', 'v3', http=creds.authorize(Http()))

# Call the Calendar API
now = datetime.datetime.utcnow().isoformat() + 'Z' # 'Z' indicates UTC time
events_result = service.events().list(calendarId='primary', timeMin=now,
                                      maxResults=5, singleEvents=True,
                                      orderBy='startTime').execute()
events = events_result.get('items', [])

if not events:
    print('No upcoming events found.')
for event in events:
    start = event['start'].get('dateTime', event['start'].get('date'))
    try:
        temp = start.split("T")
        date = temp[0].split("-")
        time = temp[1].split("+")[0].split(":")
        start = date[2] + "." + date[1] + "." + date[0] + " " + time[0] + ":" + time[1]
    except:
        date = start.split("-")
        start = date[2] + "." + date[1] + "." + date[0]
    text = text + start + " " + event['summary'] + "\n"


with open("/root/Spiegel/RAM/Kalender.txt", "w") as out:
    out.write(text)
    os.system("touch /root/Spiegel/RAM/refresh")
    out.close()
