#!/usr/bin/env python3
# -*- coding: utf-8 -*-

#=========================================================================================================================================================================
#=========================================================================================================================================================================
#== Made by Jonas Leder                                                                                                                                                 ==
#== This Script will scan the complete blitzortung.org site and bring all lightning scanners on a google Map.                                                           ==
#== Please check the path in the variable "speicherort", it must the same like the path where your html file is located also check the Name in the variable "Dateiname" ==
#== maybe you would like to change it, but I doesn't recommend. If you change the variable "dateiname" you must change also the name in the html file.                  ==
#== Please also use your Google Geocoding api keys. You must use more than one keyto scan the comlete site more then one time a day,                                    ==
#== because there is a limit by google.                                                                                                                                 ==
#=========================================================================================================================================================================
#=========================================================================================================================================================================

#Import the needed librarys:
from __future__ import unicode_literals
import requests
from geopy.geocoders import *
from geopy.exc import *
from termcolor import *
import time
import os
import sys

#Variables:
speicherort = '/var/www/blitzortung/'
dateiname = 'Marker2.js'
useragent = 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36' #Useragent from Google Chrome 65.0.3325 on windows
api_keys=["AIzaSyBYZ2z4zcTrdDt6r5TpB4aiI1EkLS2xRms", "AIzaSyCVbyw_zOE8JDV9I0MLlBYYvLBXLUT7Vnw", "AIzaSyAp6SFeurxV1dUADONQ182j7NpsPcO1MYs", "AIzaSyASzh36yBUfWZ47AsnbpYC8A9dhkut2b_Y", "AIzaSyCCUnpfGkSkLxlSNkM4asCz285JqNicF_U", "AIzaSyAn_DM_2ec20jMVzKZ2d3GHlrDpFMx_K_o", "AIzaSyDMJzBtQa7Isj_Gf6K_5yUpSyCDHy624hg", "AIzaSyBfO92U-MVRXoWzjJxdkCZxVjVpGPx9iF0", "AIzaSyCserv8q75Tq-NuAmKBFoa24M3KfdoAmRI"]

key_number = 0
city = ""
country = ""

# For counter
c = 0
no_location = 0
offline = 0
online = 0
idle = 0
unknown = 0


geolocator = GoogleV3(format_string="%s, Cleveland OH", api_key=api_keys[key_number])

def NextKey(key_number, city, country):
    print("key nr. " + str(key_number) + " has reached his limit, switching to next key")
    key_number = key_number + 1
    if(key_number >= len(api_keys)):
        print("No keys left, exiting, please provide more keys!!!")
        out.seek(-1, 2)
        out.write(bytes("\n];\n", 'utf-8'))
        out.write(bytes("online = " + str(online) + ";\n", "utf-8"))
        out.write(bytes("offline = " + str(offline) + ";\n", "utf-8"))
        out.write(bytes("idle = " + str(idle) + ";\n", "utf-8"))
        out.write(bytes("unknown = " + str(unknown) + ";\n", "utf-8"))
        out.write(bytes("status = \"not complete, not enough api keys\"", "utf-8"))
        exit()
    else:
        try:
            geolocator = GoogleV3(format_string="%s, Cleveland OH", api_key=api_keys[key_number])
            address, (lat, lon) = geolocator.geocode(city + " " + country)
            return {"key_number":key_number, 'lat':lat, 'lon':lon, 'geolocator':geolocator}
        except GeocoderQuotaExceeded as e:
            return NextKey(key_number, city, country)
        except KeyboardInterrupt :
            exit()

with open (dateiname, 'wb') as out:

    out.write(bytes('var locations = [', 'utf-8')) # open the variable

    r = requests.get('http://de.blitzortung.org/station_list.php?&region_country=-&stations_users=0&sort_column=stations.station&sort_order=asc&limit_rows=92233720368547758070000000000', headers={'user-agent': useragent}) #get all stations
    table = r.text.split("<tr style=")
    if (len(sys.argv) > 1):
        temp = []
        for i in range(0, int(sys.argv[1])):
            temp.append(table[i])
        table = temp

    for element in table:
        c = c + 1
        table_line = element.split("<td class=\"")
        if(len(table_line) >= 17):
            country = table_line[5].split("l\">")[1].split("</td>")[0].encode("utf-8").decode("ascii", 'ignore')
            city = table_line[3].split("<span title=")[1].split("\"")[1].encode('ascii',errors='ignore').decode("ascii", 'ignore')
            try:
                address, (lat, lon) = geolocator.geocode(city + " " + country)

            except GeocoderQuotaExceeded as e: # use next API keys, when key limit is reached
                result = NextKey(key_number, city, country)
                key_number = result['key_number'] # Read response variables and write it to the original variable.
                lat = result['lat']
                lon = result['lon']
                geolocator = result['geolocator']
            except:
                country = ""
                city = ""
            status = table_line[6].split("\">")[1].split("</td>")[0]
            if(status == "Offline"):
                color = "red"
                offline = offline + 1
            elif(status == "Running"):
                color = "green"
                online = online + 1
            elif(status == "Idle"):
                color = "ltblue"
                idle = idle + 1
            elif(status == "Unknown"):
                color = "blue"
                unknown = unknown + 1
            elif(status == "Bad GPS"):
                color = "red"
                offline = offline + 1
            else:
                color = "blue"
                unknown = unknown + 1

            color2 = color
            if(color2 == "ltblue"):
                color2 = "blue"

            ID = table_line[2].split('r">')[1].split("</td>")[0]
            if (country != "" and city != ""): # add only when city and country are not empty
                print(colored("(" + str(c) + "/" + str(len(table)) + ") City: " + city + " Lat:" + str(lat) + " Lon: " + str(lon) + " Status: " + status, color2))
                out.write(bytes('\n        ["', 'utf-8'))
                if(color == "green"):
                    out.write(bytes('<img src=\'https://images.lightningmaps.org/blitzortung/europe/index.php?graph_statistics=ratio_bearing&lang=de&bo_station_id=' + ID + '\' width=\'200\'><br>', "utf-8"))
                out.write(bytes('City: ' + city + '<br> Country: ' + country + '<br>Status: ' + status + '<br>ID: <a href=\'https://www.lightningmaps.org/blitzortung/europe/index.php?bo_page=statistics&bo_show=station&bo_sid=' + ID + '\'>' + ID + '</a>",', 'utf-8'))
                out.write(bytes(str(lat) + ', ' + str(lon) + ', "', 'utf-8'))
                out.write(bytes('https://www.lightningmaps.org/blitzortung/europe/index.php?bo_page=statistics&bo_show=station&bo_sid=' + ID + '", "', 'utf-8'))
                out.write(bytes(color + '"],', 'utf-8'))
            else:
                no_location = no_location + 1

    out.seek(-1, 2) # Remove the "," at the last entry
    out.write(bytes("\n];\n", 'utf-8'))
    out.write(bytes("online = " + str(online) + ";\n", "utf-8")) # Add statistic at the end as Variable for future use
    out.write(bytes("offline = " + str(offline) + ";\n", "utf-8"))
    out.write(bytes("idle = " + str(idle) + ";\n", "utf-8"))
    out.write(bytes("unknown = " + str(unknown) + ";\n", "utf-8"))
    out.write(bytes("all = " + str(c) + ";\n", "utf-8"))
    out.close()

os.system("sudo mv " + dateiname + " " + speicherort)
print("Online: " + str(online))
print("Offline: " + str(offline))
print("Idle: " + str(idle))
print("Unknown: " + str(unknown))
print("no position: " + str(no_location))
print("all: " + str(c))
if(key_number > 0):
    print("there are " + str(key_number) + " blocked keys. (too many requests today)")
